# Angular Workshop

This topic covers a wide variety of Angular features; we start with the basics, and quickly increase in depth. You will learn while building an Angular application.

## Topic Outlines:

### 1. Introduction
* Versions of Anguar
* Language Choices
* Selecting an Editor
* Setting up Our Environment
* What We'll Be Building
* A Conceptual Overview of Angular

### 2.  Introduction to Typescript
* Installing
* Compiling TypeScript
* Introduction to let, const
* Arrow Functions
* Array methods
* Static Typing
* Classes
* Interfaces
* Generics
* Modules

### 3.  Getting Started 
* Angular CLI
* Setting up an Angular Application
* Running an Angular Application
* Introduction to ES Modules
* Introduction to Angular Modules

## Checklist and Summary for Session One 

### 4. Introduction to Component 
* What Is a Component? 
* Creating the Component Class
* Defining the Metadata with a Decorator
* Importing What We Need
* Bootstrapping Our App Component

### 5. Templates, Interpolation, and Directives
* Building a Template 
* Binding with Interpolation
* Introduction to Directives

### 6. Data Binding and Pipes 
* Property Binding 
* Handling Events with Event Binding
* Handling Input with Two-way Binding
* Transforming Data with Pipes

### 7.  Improving Our Components
* Strong typing & interfaces 
* Encapsulating styles
* Lifecycle hooks

### 8.  Communicating Between Components
* Smart and dumb components overview
* Building a Nested Component
* Using a Nested Component
* Passing Data to a Nested Component Using @Input
* Passing Data from a Component Using @Output
* Parent to Child Communication with ViewChild

## Checklist and Summary for Session Two

### 9.  Services and Dependency Injection
* Introduction
* How Does It Work?
* Building a Service
* Registering the Service
* Injecting the Service


### 10. RxJs and HTTP
* RxJs: Observables, Operators, Observer
* Async Pipe
* Using Http in Angular
* Sending an HTTP Request
* Exception Handling
* Subscribing to an Observable

### 11. Routing
* Introducing Routing
* Adding the Routing Module to an App
* Adding Routing to Templates
* Sending and Receiving Route Parameters
* Subscribing to Route Parameters
* Route Guards
* Applying Route Guards
* Child Routes

## Checklist and Summary for Session Three

### 12. Angular Form
* Template-driven forms
* Template form validators
* Reactive forms
* Creating forms with form builder
* Validating with FormBuilder
* Custom validators

### 13. Angular Modules
* Types of Feature Modules
* Eager Loading
* Lazy Loading
* Defining Preload Strategies
* Feature Module Types
* Identifying Feature Modules
* Share/Core Modules

### 14. Unit Testing
* Introduction
* Isolated Tests
* Shallow Testing
* Integration Testing
* Using Angular within Jasmine unit tests

### 15. Change Detection & State management
* Introduction to Change Detection
* Angular OnPush Change Detection
* Introduction to State management
* Introduction to Ngrx/ Akita

## Final


